{% extends "base.html" %}
{% load static %}
{% load i18n %}
{% load crispy_forms_tags %}

{% block scripts %}
    <script>
        function deleteServer(url) {
            jQuery('#delete_server').attr('href', url);
            jQuery('#delete_server_modal').modal('toggle');
        }
    </script>
{% endblock %}

{% block content %}
    <section class="content">
        <div class="container-fluid">
            <div class="row mb-1">
                <div class="col-12 card">
                    <div class="card-body">
                        {% crispy filter.form filter.form.helper %}
                    </div>
                </div>
            </div>
            <div class="row">
                <div class="col-12">
                    <div class="card">
                        <div class="card-header">
                            <h3 class="card-title" id="table_desc">{% trans "Server overview" %}<span
                                    class="badge badge-pill badge-primary ml-1">{{ filter.qs.count }}</span></h3>
                            <div class="card-tools">
                                <a class="btn btn-sm btn-default float-right" href="{% url 'server_create' %}"><em
                                        class="fas fa-plus"></em></a>
                            </div>
                        </div>
                        <!-- /.card-header -->
                        <div class="card-body table-responsive p-0">
                            <table aria-describedby="table_desc" class="table table-hover table-sm">
                                <thead class="thead-light">
                                <tr>
                                    <th scope="col">{% trans "Tenant" %}</th>
                                    <th scope="col">{% trans "DNS" %}</th>
                                    <th scope="col">{% trans "State" %}</th>
                                    <th scope="col">{% trans "Datacenter" %}</th>
                                    <th scope="col">{% trans "Participants" %}</th>
                                    <th scope="col">{% trans "Videostreams" %}</th>
                                    <th scope="col">{% trans "Rooms" %}</th>
                                    <th scope="col">{% trans "Utilization" %}</th>
                                    <th scope="col">{% trans "Health Check" %}</th>
                                    <th scope="col" class="text-right">{% trans "Action" %}</th>
                                </tr>
                                </thead>
                                <tbody>
                                <!-- empty table row to fix data table tooltip bug with only one entry -->
                                <tr>
                                    <td></td>
                                    <td></td>
                                    <td></td>
                                    <td></td>
                                    <td></td>
                                    <td></td>
                                    <td></td>
                                    <td></td>
                                    <td></td>
                                    <td></td>
                                </tr>
                                {% for server in filter.qs %}

                                    <tr>
                                        <td>{{ server.tenant|default_if_none:"-" }}</td>
                                        <td>{{ server.dns }}</td>

                                        <td>{% include "snippet_server_state.html" with state=server.state %}</td>
                                        <td>{{ server.datacenter }}</td>
                                        <td>{{ server.get_participant_count }}
                                            / {{ server.participant_count_max }}</td>
                                        <td>{{ server.get_videostream_count }}
                                            / {{ server.videostream_count_max }}</td>
                                        <td>{{ server.room_set.all.count }}</td>
                                        <td>{% include "snippet_progress_bar.html" with progress=server.get_utilization_percent %} {{ server.get_utilization_percent }}%</td>
                                        <td>{{ server.last_health_check|timesince }}</td>

                                        <td>
                                            <div class="btn-group btn-group-sm float-right">
                                                <a class="btn btn-success"
                                                   href="{% url 'server_update' server.pk %}"
                                                   data-toggle="tooltip" data-placement="top"
                                                   title="{% trans "Edit" %}">
                                                    <em class="fas fa-pen"></em>
                                                </a>
                                                <button class="btn btn-danger"
                                                        onclick="deleteServer('{% url "server_delete" server.pk %}')"
                                                        data-toggle="tooltip" data-placement="top"
                                                        title="{% trans "Delete" %}">
                                                    <em class="fas fa-trash-alt"></em>
                                                </button>
                                            </div>

                                        </td>
                                    </tr>
                                {% endfor %}

                                </tbody>
                            </table>
                        </div>
                        <!-- /.card-body -->
                    </div>
                </div>
            </div>
        </div>

    </section>

    <div id="delete_server_modal" class="modal fade" tabindex="-1" role="dialog"
         aria-labelledby="CenterModalLabel"
         aria-hidden="true" style="display: none;">
        <div class="modal-dialog modal-dialog-centered">
            <div class="modal-content">
                <div class="modal-header">
                    <h4 class="modal-title" id="CenterModalLabel">{% trans "Delete server" %}</h4>
                    <button type="button" class="close" data-dismiss="modal" aria-hidden="true">×</button>
                </div>
                <div class="modal-body">
                    {% trans "Are you sure you want to delete the server?" %}
                </div>
                <div class="modal-footer">
                    <a class="btn btn-danger" href=""
                       data-toggle="tooltip" data-placement="top" title="Löschen" id="delete_server">
                        {% trans "Delete" %}
                    </a>
                    <button type="button" class="btn btn-secondary waves-effect"
                            data-dismiss="modal">{% trans "Cancel" %}</button>
                </div>
            </div><!-- /.modal-content -->
        </div><!-- /.modal-dialog -->
    </div>
{% endblock %}
